# 15-412 Simics mods v0.3
# Yuen-Lin Tan (tyl@cmu.edu)

logFile = "kernel.log"

print "15-412mods v0.3 initialized."

# Utility functions
eval_sym = SIM_get_class_interface("symtable", "symtable").eval_sym
def eval_expr(cpu, expr):
    return eval_sym(cpu, expr, [], '')

def readString(mem_addr):
    ret = ""
    for i in range(256):
        phy_addr = SIM_logical_to_physical(conf.cpu0, Sim_DI_Data, mem_addr+i)
        char = SIM_read_byte(conf.phys_mem0, phy_addr)
        ret = ret + ('%c' % char)
        if (char == 0):
            break
    return ret

# Prints user-supplied string to Simics console and file
def print_log(dummy, cpu, param):
    cpu = conf.cpu0

    # Check if lprintf() triggered magic instruction
    str_flag = SIM_read_register(cpu, SIM_get_register_number("ebx"))
    if "%x" % str_flag == "2badd00d":
        print "Magic Breakpoint reached."
        SIM_processor_break(cpu, 2)
        return
    elif "%x" % str_flag != "1badd00d":
        return

    outFile = file(os.environ["OS_PROJ_PATH"] + "/" + logFile, "a")
    
    str_addr = SIM_read_register(cpu, SIM_get_register_number("eax"))
    str = readString(str_addr)
    str = str.replace("\\n", '\n')
    print str
    outFile.write(str)
    outFile.close()
    
SIM_hap_register_callback("Core_Magic_Instruction", print_log, 0)
